// #region pinia
// #region draftSchema
export type draftSchema = draftSchemaList[];
export type draftSchemaTable_columns = {
  key: string;
  title: string;
  width: string;
  textAlign: string;
  isLink: true;
  trancate_word: number;
};
export type draftSchemaTabsForm_items = {
  key: string;
  label: string;
  type: string;
  required: string;
  classes: string;
  rows: string;
  options: [{ value: string; title: string }];
};
export type draftSchemaTabsItemsItems = {
  hideInCreateEntity: number;
  key: string;
  label: string;
  type: string;
  placeholder: string;
  required: string;
  validation_regex: string;
  validation_error: string;
  multi_select: string;
  options: [{ value: string; title: string }];
  labelClass: string;
  inputClass: string;
  classes: string;
  rows: string;
};
export type draftSchemaTabsItems = {
  title: string;
  key: string;
  type: string;
  items: draftSchemaTabsItemsItems[];
};
export type draftSchemaTabs = {
  title: string;
  componentName: string;
  key: string;
  index_key: string;
  to_index_key: string;
  description: string;
  step: number;
  items: draftSchemaTabsItems[];
  form_items: draftSchemaTabsForm_items[];
};
export type draftSchemaList = {
  key: string;
  index_key: string;
  label: string;
  table_columns: draftSchemaTable_columns[];
  tabs: draftSchemaTabs[];
};
// #endregion draftSchema
// #region draftActiveSchema
export type draftActiveSchema = draftSchemaList;
// #endregion draftActiveSchema
// #region draftActiveStep
export type draftActiveStep = {
  title: string;
  componentName: string;
  key: string;
  step: number;
  items: draftActiveStepItems[];
};
export type draftActiveStepItems = {
  key: string;
  label: string;
  type: string;
  placeholder:string;
  required: string;
  classes: string;
  rows: string;
};
// #endregion draftActiveStep
// #endregion pinia

// #region api 

// #endregion api 